/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.AgamaDto;
import com.portofolio.dto.ObjekModulAplikasiDto;
import com.portofolio.service.ObjekModulAplikasiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/objekModulAplikasi")
public class ObjekModulAplikasiController extends LocaleController {
	@Lazy
	@Autowired
	private ObjekModulAplikasiService objekModulAplikasiService;
	
	@ApiOperation("Api Untuk Menyimpan Objek Modul Aplikasi")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody ObjekModulAplikasiDto dto, HttpServletRequest request) {
		Map<String, Object> result = objekModulAplikasiService.save(dto);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Semua Objek Modul Aplikasi")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> find(
			@RequestParam(value = "dir", defaultValue = "namaObjekModulAplikasi") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaObjekModulAplikasi", required = false, defaultValue = "") String namaObjekModulAplikasi) {
		Map<String, Object> result = objekModulAplikasiService.grid(sort, dir, namaObjekModulAplikasi);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Semua Objek Modul Aplikasi Combo")
	@GetMapping("/combo")
	public ResponseEntity<Map<String, Object>> combo(
			@RequestParam(value = "dir", defaultValue = "namaObjekModulAplikasi") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaObjekModulAplikasi", required = false, defaultValue = "") String namaObjekModulAplikasi) {
		Map<String, Object> result = objekModulAplikasiService.combo(sort, dir, namaObjekModulAplikasi);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan ObjekModulAplikasi")
	@GetMapping("/findByKdObjekModulAplikasi")
	public ResponseEntity<Map<String, Object>> findByKdObjekModulAplikasi(
			@RequestParam(value = "kdObjekModulAplikasi", required = true)String kdObjekModulAplikasi,
			@RequestParam(value = "isHierarki", required = true) boolean isHierarki
			) {
		Map<String, Object> result = objekModulAplikasiService.findByKdObjekModulAplikasi(kdObjekModulAplikasi, isHierarki);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Update ObjekModulAplikasi")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdObjekModulAplikasi", required = true) String kdObjekModulAplikasi,
			@RequestParam(value = "version", required = true) Integer version, 
			@Valid @RequestBody ObjekModulAplikasiDto entity,
			HttpServletRequest request) {
		Map<String, Object> result = objekModulAplikasiService.update(entity,kdObjekModulAplikasi,version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	
	
	@ApiOperation("Api Untuk Update ObjekModulAplikasi")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> delete(
			@RequestParam(value = "kdObjekModulAplikasi", required = true) String kdObjekModulAplikasi,
			@RequestParam(value = "version", required = true) Integer version,
			HttpServletRequest request) {
		Map<String, Object> result = objekModulAplikasiService.delete(kdObjekModulAplikasi, version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	
	
	

}
